##############################################################################
# 
#          DMU125  
#                Heidenhain TNC-530
#
# System:  "Heidenhain TNC-530"
# Machine: "DMU125P"
# Type: MILL 5x
#
################################################################################
# 
#
#   	        	   			
#   17   2003	          0. Original
#    25.10.2003    	  	  1.   . PB_limit_angle   
#                                                     mom_out_angle_pos(0)  mom_out_angle_pos(0)
#	1  2003   	                 MOM_force once  X Y Z   MOM_do_template from_move
#   14.01.2004    	                     ;    MOM_rapid_move
#                                                          (   z  xy )
#   29.04.2004    	                   M129
#   30.04.2004    	                   M129
#   26.11.2004    	                    MOM_circular_move
#   30.11.2004                              128  129 ,    . (DMU50)
#   30.01.06                             QUADRANT  FULL_CIRCLE
# $$
#
#
################################################################################

#=============================================================
#      .
#=============================================================
# source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_debug.tcl ;
# source [MOM_ask_env_var UGII_CAM_DEBUG_DIR]mom_review.tcl ; MOM_set_debug_mode ON

#=============================================================
#        .
#=============================================================

 source "[MOM_ask_env_var UGII_CAM_POST_DIR]ugpost_base.tcl"

#=============================================================
#    UGPost  .
#=============================================================

	set mom_kin_arc_valid_plane		XYZ
	set mom_kin_output_unit			MM
        set mom_kin_arc_output_mode			        FULL_CIRCLE; # QUADRANT
	set mom_kin_machine_type		5_axis_head_table
	set mom_kin_4th_axis_limit_action	"Retract / Re-Engage"
	set mom_kin_5th_axis_limit_action	"Retract / Re-Engage"

#	set mom_kin_read_ahead_next_motion	TRUE
	set mom_kin_machine_resolution		0.001
	set mom_kin_track_center_of_ball	FALSE
	set mom_kin_4th_axis_type               "Head"
	set mom_kin_4th_axis_plane		YZ
	set mom_kin_4th_axis_min_incr		0.001
	set mom_kin_4th_axis_min_limit		-120.000
	set mom_kin_4th_axis_max_limit		10.000
	set mom_kin_4th_axis_direction		MAGNITUDE_DETERMINES_DIRECTION
	set mom_kin_4th_axis_rotation		standard
	set mom_kin_4th_axis_zero		0.0
	set mom_kin_4th_axis_center_offset(0)	0.0
	set mom_kin_4th_axis_center_offset(1)	0.0
	set mom_kin_4th_axis_center_offset(2)	0.0
        set mom_kin_4th_axis_leader             "A"
	set mom_kin_pivot_gauge_offset		0.0

        set mom_kin_5th_axis_type               "Table"
	set mom_kin_5th_axis_plane		XY
	set mom_kin_5th_axis_min_incr		0.001
	set mom_kin_5th_axis_min_limit		-99999.000
	set mom_kin_5th_axis_max_limit		99999.000
	set mom_kin_5th_axis_direction		MAGNITUDE_DETERMINES_DIRECTION
	set mom_kin_5th_axis_rotation		standard
	set mom_kin_5th_axis_zero		0.0

	set mom_kin_5th_axis_center_offset(0)	0.0
	set mom_kin_5th_axis_center_offset(1)	0.0
	set mom_kin_5th_axis_center_offset(2)	0.0
	set mom_kin_5th_axis_leader             "C"

	set mom_kin_linearization_flag		TRUE
#	set mom_kin_independent_head		NONE
	set mom_kin_nurbs_output_type		HEIDENHAIN_POLY
	 set mom_kin_clamp_time                        "2.0"
  set mom_kin_flush_time                        "2.0"
  set mom_kin_linearization_flag                "1"
  set mom_kin_linearization_tol                 "0.001"
  set mom_kin_max_arc_radius                    "9998.0" ; # 9999.999
  set mom_kin_max_dpm                           "5400"
  set mom_kin_max_fpm                           "15000"
  set mom_kin_max_fpr                           "1000"
  set mom_kin_max_frn                           "999999"
  set mom_kin_min_arc_length                    "0.01" ; # 0.001
  set mom_kin_min_arc_radius                    "0.011" ; # 0.001
  set mom_kin_min_dpm                           "0.0"
  set mom_kin_min_fpm                           "0.1"
  set mom_kin_min_fpr                           "0.1"
  set mom_kin_min_frn                           "0.01"
  set mom_kin_post_data_unit                    "MM"
  set mom_kin_rapid_feed_rate                   "40000"
  set mom_kin_tool_change_time                  "0.2"
  set mom_kin_x_axis_limit                      "1250"
  set mom_kin_y_axis_limit                      "880"
  set mom_kin_z_axis_limit                      "800"


#=============================================================
#       G  M 
#=============================================================

	set mom_sys_program_stop_code              	0
	set mom_sys_optional_stop_code             	1

	set mom_sys_spindle_direction_code(NONE)    	3
	set mom_sys_spindle_direction_code(CLW)    	3
	set mom_sys_spindle_direction_code(CCLW)        4
	set mom_sys_spindle_direction_code(OFF)    	5

	set mom_sys_tool_change_code               	6

	set mom_sys_coolant_code(MIST)             	7
	set mom_sys_coolant_code(FLOOD)            	8
	set mom_sys_coolant_code(ON)               	8
	set mom_sys_coolant_code(TAP)              	8
	set mom_sys_coolant_code(OFF)              	9

	set mom_sys_clamp_code(ON)                 	10
	set mom_sys_clamp_code(OFF)                	11
	set mom_sys_clamp_code(AXISON)             	10
	set mom_sys_clamp_code(AXISOFF)            	11

	set mom_sys_end_of_program_code            	30

	set mom_sys_rapid_code                     	0
	set mom_sys_linear_code                    	1
	set mom_sys_circle_code(CLW)               	2
	set mom_sys_circle_code(CCLW)              	3
	set mom_sys_mcs_rotation_code              	7

	set mom_sys_cutcom_code(OFF)               	"0"
	set mom_sys_cutcom_code(LEFT)              	"L"
	set mom_sys_cutcom_code(RIGHT)             	"R"

	set mom_sys_inch_code                      	70
	set mom_sys_metric_code                    	71

	set mom_sys_output_code(ABSOLUTE)          	90
	set mom_sys_output_code(INCREMENTAL)	        91

  set mom_sys_leader(N)                         ""
  set mom_sys_leader(X)                         "X"
  set mom_sys_leader(Y)                         "Y"
  set mom_sys_leader(Z)                         "Z"
  set mom_sys_leader(fourth_axis)               "A"
  set mom_sys_leader(fifth_axis)                "C"
	set mom_sys_leader(Circle_radius) 		"R"
	set mom_sys_leader(Circle_angle)      "PA"
	set mom_sys_leader(Polar_radius)      "PR"

	set mom_sys_list_output				ON
	set mom_sys_commentary_output              	ON
	set mom_sys_header_output			ON
	set mom_sys_list_file_rows			80
	set mom_sys_list_file_columns			132
	set mom_sys_warning_output			ON
	set mom_sys_group_output			OFF
	set mom_sys_list_file_suffix			lpt
	set mom_list_file_suffix			lpt
	set mom_sys_output_file_suffix			h
	set mom_output_file_suffix			h

	set mom_sys_home_pos(0)                		400
	set mom_sys_home_pos(1)                		200
	set mom_sys_home_pos(2)                		220






#=============================================================
#   
#=============================================================

set header_check_status	            		0
set prog_start_flag                        	0
set prog_number                            	12345
set mom_cycle_rapid_to_pos(0)         		0
set mom_cycle_rapid_to_pos(1)        		0
set mom_cycle_rapid_to_pos(2)         		0
set mom_cycle_feed_to_pos(0)          		0
set mom_cycle_feed_to_pos(1)          		0
set mom_cycle_feed_to_pos(2)          		0
set mom_cycle_retract_to_pos(0)       		0
set mom_cycle_retract_to_pos(1)       		0
set mom_cycle_retract_to_pos(2)       		0
set mom_point1_pos(0) 				-100.0
set mom_point1_pos(1) 				-100.0
set mom_point1_pos(2) 				-50.0
set mom_point2_pos(0) 				100.0
set mom_point2_pos(1) 				100.0
set mom_point2_pos(2) 				0.0
set mom_offset_block				0.0
set mom_smooth_path				"OFF"
set mom_tolerance_on_off			"OFF"
set tolerances				        0.01
set mom_small_steps				"OFF"
set status_block_create				0
set cutcom_on 					0
set mom_zero_point_set 				88
set status_tool_change				0
set mom_prev_pos_z				-9999.999
set first_move_after_MCSROT			0
set MCSROT_flag					0
set is_MCSROT_matrix_set			0
set first_motion_flag				0
set spindle_off_flag 				0
set mom_contact_status				UNDEFINED ; # ON
set mom_cycle_status				UNDEFINED
set mom_cycle_delay				0.1
set mom_output_vectors_on			"OFF"
set code_cutcom                                 0
set out_m128                                    129
set status_rot     0
set status_rot_m     0
set status_rot_ini 0
set a_angle  0
set b_angle  0
set c_angle  0
set   mom_machine_time_dmu                        0
set   mom_machine_time_dmu_1                        0
set nn 0
 	set  angle  0

#=============================================================
proc  MOM_start_of_program {} {
#       .
#=============================================================
	global mom_part_name
	global is_from
	global mom_cutcom_status mom_cutcom_mode
	global mom_spindle_rpm

#      UNDEFINED
	  set mom_coolant_status 	UNDEFINED
	  set mom_cutcom_status  	UNDEFINED
  	set mom_clamp_status   	UNDEFINED
  	set mom_cycle_status   	UNDEFINED
  	set mom_spindle_status 	UNDEFINED
  	set mom_cutcom_plane   	UNDEFINED

#   
	  catch {unset mom_cutcom_adjust_register}
	  catch {unset mom_tool_adjust_register}
  	catch {unset mom_tool_length_adjust_register}
  	catch {unset mom_length_comp_register}
  	catch {unset mom_flush_register}
  	catch {unset mom_wire_cutcom_adjust_register}

#     
	OPEN_files
#       
	LIST_FILE_HEADER

	global mom_warning_info
	set mom_warning_info "\n  DMU125P ( - HEIDENHAIN)\n"
  MOM_output_to_listing_device $mom_warning_info  ; #  MOM_catch_warning ;

	set is_from ""
	set mom_spindle_rpm 0.0
}


#=============================================================
proc MOM_msys {} {
#       MOM_msys
#=============================================================
	global status_block_create mom_tolerance_on_off
	global status_zero_shift mom_spindle_speed tolerances zero_g_code
#         
#       iTNC-530
	if {$status_block_create == "0"} {
		MOM_block_create
#		MOM_output_literal "L M129"
	}
#        

}


#=============================================================
proc MOM_operator_message {} {
#        
#=============================================================
     global mom_operator_message
     MOM_output_literal ";$mom_operator_message"
}


#=============================================================
proc MOM_end_of_program { } {
#       
#=============================================================
   	global mom_group_name mom_machine_time line1 mom_machine_time_dmu mom_machine_time_dmu_1
   	global mom_kin_tool_change_time mom_tool_count warning_1 nn
   	global status_rot  b_angle c_angle  a_angle

#   19 (  )      

	  if {$a_angle!=0.0 ||$b_angle!=0.0 || $c_angle != 0.0 } {
	  		set    a_angle  0
	  	  set    b_angle  0
	  	  set    c_angle  0
	  		set rot_table_1 [format "CYCL DEF 19.0 WORKING PLANE"]
			  set rot_table_2 [format "CYCL DEF 19.1 A%.3f B%.3f C%.3f F2000 " $a_angle $b_angle $c_angle]
	      MOM_force once Axis_4th Axis_5th
	      MOM_output_literal "$rot_table_1"
	      MOM_output_literal "$rot_table_2"
	      MOM_do_template rotate_bc
	      MOM_output_literal "CYCL DEF 19.0 WORKING PLANE"
        MOM_output_literal "CYCL DEF 19.1"
       	set status_rot  0
    }

    MOM_output_literal "M30"

    set machine_time $mom_machine_time_dmu_1
    set machine_time [ expr ($mom_tool_count*$mom_kin_tool_change_time + $machine_time ) ]
    set line1 [format "; MACHINE TIME = %.2f min " $machine_time ]
  	set tm1 [ expr int($machine_time/60.0) ]
  	set tm2 [ expr ($machine_time/60.0 - $tm1) * 60.0 ]
  	set line2 [format "( %.0f hour %.0f min)" $tm1 $tm2]
  	if {$tm1!=0} { append line1 $line2 ; }
  	set mom_machine_time $machine_time

    MOM_output_literal "$line1"

    for {set l 1} {$l <= $nn} {incr l} { MOM_output_literal "$warning_1($l)" }

    global prog_name
	  MOM_output_literal "END PGM $prog_name MM"

  	LIST_FILE_TRAILER

  	CLOSE_files
}


#=============================================================
proc MOM_nurbs_move { } {
#       
#=============================================================
	global mom_nurbs_point_count
	global mom_nurbs_points
	global mom_nurbs_coefficients
	global xe ye ze
	global ii
	global x0 x1 x2
	global y0 y1 y2
	global z0 z1 z2
	global E_string_x0 E_string_x1 E_string_x2
	global E_string_y0 E_string_y1 E_string_y2
	global E_string_z0 E_string_z1 E_string_z2
	global nurbs_precision
	global comp_value mom_smooth_path

	set E_string_x0 ""
	set E_string_x1 ""
	set E_string_x2 ""
	set E_string_y0 ""
	set E_string_y1 ""
	set E_string_y2 ""
	set E_string_z0 ""
	set E_string_z1 ""
	set E_string_z2 ""

	MOM_force once X Y Z K3X K2X K1X K3Y K2Y K1Y K3Z K2Z K1Z

	set xe $mom_nurbs_points(0,0)
	set ye $mom_nurbs_points(0,1)
	set ze $mom_nurbs_points(0,2)

#	if {$mom_smooth_path == "ON"} {
#		MOM_do_template start_spline_m90
#	} else  {
#		MOM_do_template start_spline
#	}

	MOM_force once X Y Z K3X K2X K1X K3Y K2Y K1Y K3Z K2Z K1Z

	for {set ii 0} {$ii < [expr $mom_nurbs_point_count-1]} {incr ii} {
		set xe $mom_nurbs_points($ii,0)
		set ye $mom_nurbs_points($ii,1)
		set ze $mom_nurbs_points($ii,2)
		set nurbs_precision 1.0

		set x0 [expr $mom_nurbs_coefficients($ii,0)*$nurbs_precision]
		set x1 [expr $mom_nurbs_coefficients($ii,1)*$nurbs_precision]
		set x2 [expr $mom_nurbs_coefficients($ii,2)*$nurbs_precision]
		set y0 [expr $mom_nurbs_coefficients($ii,3)*$nurbs_precision]
		set y1 [expr $mom_nurbs_coefficients($ii,4)*$nurbs_precision]
		set y2 [expr $mom_nurbs_coefficients($ii,5)*$nurbs_precision]
		set z0 [expr $mom_nurbs_coefficients($ii,6)*$nurbs_precision]
		set z1 [expr $mom_nurbs_coefficients($ii,7)*$nurbs_precision]
		set z2 [expr $mom_nurbs_coefficients($ii,8)*$nurbs_precision]

		set comp_value [expr abs($x0)]

		if { $comp_value  >= 10.0 && $comp_value < 100.0} {
			set x0 [expr $x0/10.0] ; set E_string_x0 "E1"
		} elseif { $comp_value >= 100.0 && $comp_value < 1000.0} {
			set x0 [expr $x0/100.0] ; set E_string_x0 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set x0 [expr $x0/1000.0] ; set E_string_x0 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set x0 [expr $x0/10000.0] ; set E_string_x0 "E4"
		} else { set E_string_x0 ""}

		set comp_value [expr abs($x1)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set x1 [expr $x1/10.0] ; set E_string_x1 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set x1 [expr $x1/100.0] ; set E_string_x1 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set x1 [expr $x1/1000.0] ; set E_string_x1 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set x1 [expr $x1/10000.0] ; set E_string_x1 "E4"
		} else {
			set E_string_x1 ""}

		set comp_value [expr abs($x2)]

		if {$comp_value >=  10.0 && $comp_value < 100.0} {
			set x2 [expr $x2/10.0] ; set E_string_x2 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set x2 [expr $x2/100.0] ; set E_string_x2 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set x2 [expr $x2/1000.0] ; set E_string_x2 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set x2 [expr $x2/10000.0] ; set E_string_x2 "E4"
		} else {set E_string_x2 ""}

		set comp_value [expr abs($y0)]

		if {$comp_value >=  10.0 && $comp_value < 100.0} {
			set y0 [expr $y0/10.0] ; set E_string_y0 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set y0 [expr $y0/100.0] ; set E_string_y0 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set y0 [expr $y0/1000.0] ; set E_string_y0 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set y0 [expr $y0/10000.0] ; set E_string_y0 "E4"
		} else {set E_string_y0 ""}

		set comp_value [expr abs($y1)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set y1 [expr $y1/10.0] ; set E_string_y1 "E1"
		} elseif { $comp_value >=  100.0  && $comp_value < 1000.0} {
			set y1 [expr $y1/100.0] ; set E_string_y1 "E2"
		} elseif { $comp_value >=  1000.0  && $comp_value < 10000.0} {
			set y1 [expr $y1/1000.0] ; set E_string_y1 "E3"
		} elseif { $comp_value >=  10000.0  && $comp_value < 100000.0} {
			set y1 [expr $y1/10000.0] ; set E_string_y1 "E4"
		} else {set E_string_y1 ""}

		set comp_value [expr abs($y2)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set y2 [expr $y2/10.0] ; set E_string_y2 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set y2 [expr $y2/100.0] ; set E_string_y2 "E2"
		} elseif { $comp_value >=  1000.0 && $comp_value < 10000.0} {
			set y2 [expr $y2/1000.0] ; set E_string_y2 "E3"
		} elseif { $comp_value >=  10000.0 && $comp_value < 100000.0} {
			set y2 [expr $y2/10000.0] ; set E_string_y2 "E4"
		} else {set E_string_y2 ""}

		set comp_value [expr abs($z0)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set z0 [expr $z0/10.0] ; set E_string_z0 "E1"
		} elseif { $comp_value >=  100.0 && $comp_value < 1000.0} {
			set z0 [expr $z0/100.0] ; set E_string_z0 "E2"
		} elseif {$comp_value >=  1000.0 && $comp_value < 10000.0} {
			set z0 [expr $z0/1000.0] ; set E_string_z0 "E3"
		} elseif {$comp_value >=  10000.0 && $comp_value < 100000.0} {
			set z0 [expr $z0/10000.0] ; set E_string_z0 "E4"
		} else {set E_string_z0 ""}

		set comp_value [expr abs($z1)]

		if {$comp_value >=  10.0 && $comp_value < 100.0} {
			set z1 [expr $z1/10.0] ; set E_string_z1 "E1"
		} elseif {$comp_value >=  100.0 && $comp_value < 1000.0} {
			set z1 [expr $z1/100.0] ; set E_string_z1 "E2"
		} elseif {$comp_value >=  1000.0 && $comp_value < 10000.0} {
			set z1 [expr $z1/1000.0] ; set E_string_z1 "E3"
		} elseif {$comp_value >=  10000.0 && $comp_value < 100000.0} {
			set z1 [expr $z1/10000.0] ; set E_string_z1 "E4"
		} else {set E_string_z1 ""}

		set comp_value [expr abs($z2)]

		if { $comp_value >=  10.0 && $comp_value < 100.0} {
			set z2 [expr $z2/10.0] ; set E_string_z2 "E1"
		} elseif {$comp_value >=  100.0 && $comp_value < 1000.0} {
			set z2 [expr $z2/100.0] ; set E_string_z2 "E2"
		} elseif {$comp_value >=  1000.0 && $comp_value < 10000.0} {
			set z2 [expr $z2/1000.0] ; set E_string_z2 "E3"
		} elseif {$comp_value >=  10000.0 && $comp_value < 100000.0} {
			set z2 [expr $z2/10000.0] ; set E_string_z2 "E4"
		} else {set E_string_z2 ""}

		if {$mom_smooth_path == "ON"} {
			MOM_do_template spline_tnc_m90
		} else  {
			MOM_do_template spline_tnc
		}
	}

}


#=============================================================
proc  MOM_start_of_path {} {
#       .
#=============================================================
	global mom_path_name
	global mom_tool_name
	global mom_out_angle_pos
	global status_rot_m

	global mom_operation_name
	MOM_output_literal " ; "
	MOM_output_literal " ; $mom_operation_name "

        if {$status_rot_m == 0} {
	   MOM_force once M_spindle M_coolant S X Y Z R F Axis_4th Axis_5th
         } else {
	   MOM_force once M_spindle M_coolant S X Y Z R F
	   MOM_suppress once Axis_4th Axis_5th M128
        }
}


#=============================================================
proc  MOM_end_of_path {} {
#       
#=============================================================
	global mom_path_name
	global first_motion_flag
   	global status_rot a_angle b_angle c_angle

#   19 (  )      
	if {$status_rot == 1} {
	   set rot_table_1 [format "CYCL DEF 19.0 WORKING PLANE"]
	   set rot_table_2 [format "CYCL DEF 19.1 A%.3f B%.3f C%.3f F2000 " $a_angle $b_angle $c_angle]
	   if {$a_angle==0.0 &&$b_angle==0.0 &&$c_angle == 0.0 } {
	       MOM_force once Axis_4th Axis_5th
	        MOM_output_literal "$rot_table_1"
	        MOM_output_literal "$rot_table_2"
	        MOM_do_template rotate_bc
	        MOM_output_literal "CYCL DEF 19.0 WORKING PLANE"
                MOM_output_literal "CYCL DEF 19.1"
        	set status_rot  0
  	   }
	}
	set first_motion_flag 0
	MOM_suppress off I J K
}


#=============================================================
proc MOM_start_of_group {} {
#      UG   ,
#    
#=============================================================
	global mom_output_file_basename mom_group_name
	global header_check_status mom_operation_name
	global mom_date mom_machine_name mom_logname
	global mom_ug_version

  global prog_name
  set prog_name ""
  if {[info exists mom_operation_name]} { set prog_name $mom_operation_name }
  if {[info exists mom_group_name]} { set prog_name $mom_group_name }

	set prog_name $mom_output_file_basename

	if { $header_check_status == 0} {
		set prog_name [string toupper $prog_name]
		MOM_output_literal "BEGIN PGM $prog_name MM"
# 		MOM_do_template sel_table
		set mom_ug_version [string toupper $mom_ug_version]
		MOM_output_literal "; GENERATE BY: $mom_ug_version"
		set mom_machine_name [string toupper $mom_machine_name]
		MOM_output_literal "; MACHINE: $mom_machine_name"
		set mom_date [string toupper $mom_date]
		MOM_output_literal "; DATE: $mom_date"
		set mom_logname [string toupper $mom_logname]
		MOM_output_literal "; PROGRAMMER: $mom_logname"
		set header_check_status 1
	}
}


#=============================================================
proc MOM_end_of_group {} {
#      
#=============================================================
}


#=============================================================
proc  MOM_tool_change {} {
#      
#=============================================================
	global mom_tool_name status_tool_change
	set status_tool_change 0
}


#=============================================================
proc  MOM_first_tool {} {
#       
#=============================================================
	global mom_tool_name
}


#=============================================================
proc  MOM_initial_move {} {
#         .
#=============================================================
	global first_motion_flag mom_cycle_status mom_motion_type mom_tool_axis
	global mom_prev_pos_z mom_pos_z leader_4th leader_5th status_rot rot_table_1 rot_table_2 rot_table_3
        global mom_imported_path_status mom_rotation_angle
        global mom_kin_arc_output_mode mom_operation_name mom_warning_info mom_tolerance_on_off
        global a_angle b_angle c_angle status_rot status_rot_m mom_out_angle_pos
#     ,     
#     ,    .
#                         !!!!!!
	set leader_4th "A"
	set leader_5th "C"

	#        
	if {$mom_tolerance_on_off == "ON"} {
  		MOM_do_template tolerances_1
  		MOM_do_template tolerances_2
#  		MOM_do_template tolerances_3
  	}
#    
	MOM_spindle_rpm

#   19 (  )      
		if {$status_rot == 1} {
			set rot_table_1 [format "CYCL DEF 19.0 WORKING PLANE"]
			set rot_table_2 [format "CYCL DEF 19.1 A%.3f B%.3f C%.3f F2000 " $a_angle $b_angle $c_angle]
	  if {$a_angle!=0.0 ||$b_angle!=0.0 ||$c_angle != 0.0 } {
	MOM_force once Axis_4th Axis_5th

	        MOM_output_literal "$rot_table_1"
	        MOM_output_literal "$rot_table_2"
	        MOM_do_template rotate_bc
	        	set status_rot  0
	}
      } else {
	MOM_output_literal "L A0 C0 R0 FMAX"
}
	  if {[info exists mom_imported_path_status]==1} {
     if {"YES"==[string toupper "$mom_imported_path_status"]} {
       set mom_warning_info "WARNING: =$mom_operation_name -   ( -   !)"
       MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;

      } else {
      	      		MOM_force once  X Y Z
	MOM_do_template from_move
       }
   }
           MOM_reload_kinematics
	set i [format "%-.6f" $mom_tool_axis(0)]
	set j [format "%-.6f" $mom_tool_axis(1)]
	set k [format "%-.6f" $mom_tool_axis(2)]

#     if {$i=="0.0" && $j=="0.0" &&  ($k=="1.0" || $k=="-1.0" ) } {
#		    set  out_m128  129
#		MOM_force once XC YC
#		MOM_suppress once M128
#		set mom_out_angle_pos(1) 0

#		set c_value 0
# return;
#   } else {
#		MOM_force once M128
#                }
         if {  $mom_rotation_angle!=0.0 } {
          MOM_do_template fifth_axis_rotate_move
        }
           	if {$status_rot_m == 0} {
	        MOM_force once  X Y Z Axis_4th Axis_5th

                	} else {
		MOM_force once  X Y Z
		MOM_suppress always Axis_4th Axis_5th M128
		MOM_suppress once M128 Axis_4th Axis_5th
	}
	if {$mom_motion_type == "RAPID"} {
		if {$mom_cycle_status == "ON"} {
			MOM_do_template rapid_cycle_z
			MOM_do_template rapid_cycle_xy
		} else {
          	if {$mom_out_angle_pos(1) != 0  || $mom_out_angle_pos(0) != 0  } {
	            MOM_do_template rapid_xy_1
MOM_force once Axis_4th Axis_5th
}
			MOM_do_template rapid_xy
			MOM_do_template rapid_z
		}
	} elseif {$mom_motion_type == "CYCLE"} {
		MOM_do_template rapid_cycle_z
		MOM_do_template rapid_cycle_xy
	} else {
		MOM_linear_move
	}
	set first_motion_flag 1

}


#=============================================================
proc PROGRAM_START {} {
#      User Define Command
# "PARTNO"
#=============================================================
	global prog_start_flag
	global prog_number

	if {$prog_start_flag == 0} {
		MOM_suppress always N
		MOM_output_literal "BEGIN PRG $prog_number MM"
		MOM_suppress off    N
		set prog_start_flag 1
	}
}


#=============================================================
proc MOM_block_create { } {
#    2-  3-   ,  
#      
#=============================================================
	global mom_point1_pos
	global mom_point2_pos
	global status_block_create
	global mom_offset_block

	MOM_force once X Y Z
	set mom_point1_pos(0) [expr $mom_point1_pos(0)-$mom_offset_block]
	set mom_point1_pos(1) [expr $mom_point1_pos(1)-$mom_offset_block]
	set mom_point1_pos(2) [expr $mom_point1_pos(2)-$mom_offset_block]
	set mom_point2_pos(0) [expr $mom_point2_pos(0)+$mom_offset_block]
	set mom_point2_pos(1) [expr $mom_point2_pos(1)+$mom_offset_block]
	MOM_do_template start_block
	MOM_do_template end_block
	set status_block_create 1
	MOM_output_literal "L M129"
}


#=============================================================
proc MOM_first_move {} {
#        ,
#       .
#=============================================================
	global mom_motion_event status_rot_m mom_rotation_angle
	global first_motion_flag  status_rot b_angle c_angle a_angle
#	catch { MOM_$mom_motion_event }
	set first_motion_flag 1
#   19 (  )      
		if {$status_rot == 1} {
			set rot_table_1 [format "CYCL DEF 19.0 WORKING PLANE"]
			set rot_table_2 [format "CYCL DEF 19.1 A%.3f B%.3f C%.3f F2000 " $a_angle $b_angle $c_angle]
	  if {$a_angle!=0.0 ||$b_angle!=0.0 ||$c_angle != 0.0 } {

	        MOM_output_literal "$rot_table_1"
	        MOM_output_literal "$rot_table_2"

	        MOM_do_template rotate_bc
	        	set status_rot  0
	}
      }
                     	if {$status_rot_m == 0} {
	        MOM_force once  X Y Z Axis_4th Axis_5th

                	} else {
		MOM_force once  X Y Z

		MOM_suppress once M128 Axis_4th Axis_5th
	}
		        if {  $mom_rotation_angle!=0.0 } {
          MOM_do_template fifth_axis_rotate_move
        }
	catch { MOM_$mom_motion_event }
	set first_motion_flag 1
}


#=============================================================
proc MOM_from_move { } {
#       FROM,   .
#=============================================================
 global mom_from_pos mom_mcs_goto
 catch { COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET ;  MODES_SET ; }

      set  from_pos(0)  $mom_mcs_goto(0)
      set  from_pos(1)  $mom_mcs_goto(1)
      set  from_pos(2)  $mom_mcs_goto(2)
}


#=============================================================
proc MOM_gohome_move {} {
#       GOHOME,   .
#=============================================================
	global mom_pos mom_prev_pos mom_gohome_pos mom_tool_axis
	global leader_4th leader_5th mom_output_vectors_on c_adr
  global mom_operation_name

	set i [format "%-.7f" $mom_tool_axis(0)]
	set j [format "%-.7f" $mom_tool_axis(1)]
	set k [format "%-.7f" $mom_tool_axis(2)]

  #MOM_output_to_listing_device "\ni=$i\nj=$j\nk=$k\n "

  #     
  set str " $mom_operation_name \n   \n   (i,j,k)  GOHOME!!! \n  k<-0.5  k>1. "
  if { $k>1.  } { MOM_abort $str }
  if { $k<-.5 } {
    if {[llength [info commands MOM_info_message ] ]} {
      #MOM_ui_message "ERROR" $mom_warning_info
      MOM_info_message "RIGHT" $str
     } else {
      MOM_abort $str
    }
  }

  if {$mom_pos(2) < $mom_prev_pos(2) } {
   if {$mom_output_vectors_on == "ON"} {
 	MOM_force once X Y Z TX TY TZ
	MOM_do_template gohome_xy_vectors
     } else {
	set c_adr [ MOM_ask_address_value Axis_5th]
        if {$c_adr>=360.0 || $c_adr<=-360.0} { MOM_do_template gohome_ac }
   	MOM_do_template gohome_xy
    }
    MOM_do_template gohome_z
  } else {
    if {$mom_output_vectors_on == "ON"} {
	MOM_force once X Y Z TX TY TZ
	MOM_do_template gohome_z_vectors
      } else {
	MOM_do_template gohome_z
     }
    set c_adr [ MOM_ask_address_value Axis_5th]
    if {$c_adr>=360.0 || $c_adr<=-360.0} { MOM_do_template gohome_ac }
    MOM_do_template gohome_xy
 }

#   	set mom_prev_pos_z $mom_pos_z
}


#=============================================================
proc MOM_linear_move { } {
#       .
#=============================================================
	global cutcom_mode mom_cutcom_mode mom_cutcom_status
	global mom_pos mom_prev_pos
	global mom_smooth_path mom_small_steps
	global mom_motion_distance mom_tool_diameter
	global cutcom_on mom_contact_status
	global mom_output_vectors_on
	global mom_tool_axis

	set al1 [COUNT_alk $mom_pos(0) $mom_pos(1) al1]
#       MOM_output_literal "al1=  $al1"

	PB_limit_angle

	if {$mom_contact_status == "ON"} {
		MOM_force once X Y Z NX NY NZ
		MOM_do_template linear_move_3d
	} elseif {$mom_output_vectors_on == "ON"} {
		MOM_force once X Y Z TX TY TZ
		MOM_do_template linear_move_vectors
	} else {
		if {$mom_small_steps == "ON" 		&&
			$mom_cutcom_status == "ON"	&&
			$mom_motion_distance <= $mom_tool_diameter} {
				MOM_do_template feedrate_tnc
				MOM_do_template linear_move_m97
		} elseif {$mom_smooth_path == "ON"} {
			if {$cutcom_on == 1} {
				MOM_do_template linear_move
				set cutcom_on 0
			} else {
				MOM_do_template feedrate_tnc
				MOM_do_template linear_move_m90
			}
		} else  {
			MOM_do_template linear_move
		}
	}
}


#=============================================================
proc MOM_circular_move { } {
#=============================================================
	global mom_arc_direction
	global mom_arc_axis out_m128 mom_tool_axis

	set i [format "%-.6f" $mom_tool_axis(0)]
	set j [format "%-.6f" $mom_tool_axis(1)]
	set k [format "%-.6f" $mom_tool_axis(2)]

     if {$i=="0.0" && $j=="0.0" &&  ($k=="1.0" || $k=="-1.0" ) } {



	if {[format "%.6f" $mom_arc_axis(2)] == "1" || [format "%.6f" $mom_arc_axis(2)] == "-1"} {
		MOM_force once XC YC
		MOM_suppress once ZC
	} elseif {[format "%.6f" $mom_arc_axis(1)] == "1" || [format "%.6f" $mom_arc_axis(1)] == "-1"} {
		 MOM_force once XC ZC
		 MOM_suppress once YC
	} elseif {[format "%.6f" $mom_arc_axis(0)] == "1" || [format "%.6f" $mom_arc_axis(0)] == "-1"} {
		 MOM_force once YC ZC
		 MOM_suppress once XC
	}
	;#MOM_do_template feedrate_tnc
   	MOM_do_template circle_center
   	if {[format "%.6f" $mom_arc_axis(2)] == "1" || [format "%.6f" $mom_arc_axis(2)] == "-1"} {
		 MOM_force once X Y
		MOM_suppress once Z
	} elseif {[format "%.6f" $mom_arc_axis(1)] == "1" || [format "%.6f" $mom_arc_axis(1)] == "-1"} {
		 MOM_force once X Z
		 MOM_suppress once Y
	} elseif {[format "%.6f" $mom_arc_axis(0)] == "1" || [format "%.6f" $mom_arc_axis(0)] == "-1"} {
		 MOM_force once Y Z
		 MOM_suppress once X
	}
   	if { $mom_arc_direction == "CLW"} {
      		MOM_do_template circle_end_cw
   	} elseif { $mom_arc_direction == "CCLW" } {
     		MOM_do_template circle_end_ccw
   	}
  } elseif { $out_m128 == 128} {
		MOM_abort "       !!!!!"
   	}

}


#=============================================================
proc  MOM_rapid_move {} {
#     .
#=============================================================
	global mom_coolant_mode mom_coolant_status mom_output_vectors_on
	global mom_pos mom_prev_pos mom_pos_z mom_prev_pos_z

	set mom_coolant_status $mom_coolant_mode
	if {$mom_output_vectors_on == "ON"} {
		MOM_force once X Y Z TX TY TZ
		MOM_do_template rapid_xyz_vectors
	} else {
              MOM_do_template rapid_xyz

   	}
#   	set mom_prev_pos_z $mom_pos_z
}



 set mom_sys_helix_pitch_type	"none"
#
# The default setting for mom_sys_helix_pitch_type is "rise_radian".
# This is the most common.  Other choices are:
#
#    "rise_radian"              Measures the rise over one radian.
#    "rise_revolution"          Measures the rise over 360 degrees.
#    "none"                     Will suppress the output of pitch.
#    "other"                    Allows you to calculate the pitch
#                               using your own formula.
#
# This custom command uses the block template circular_move to output
# the helix block.  If your post uses a block template with a different
# name, you must edit the line that outputs the helix block.

#
#  The following variable deines the output mode for helical records.
#
#  FULL_CIRCLE  -- This mode will output a helix record for each 360
#                  degrees of the helix.
#  QUADRANT  --    This mode will output a helix record for each 90
#                  degrees of the helix.
#  LINEAR  --      This mode will output the entire helix as linear gotos.
#  END_POINT --    This mode will assume the control can define an entire
#                  helix in a single block.

# set mom_kin_helical_arc_output_mode END_POINT


#=============================================================
proc MOM_helix_move1 { } {
#=============================================================
   global mom_arc_direction  mom_arc_axis  mom_arc_angle

   global mom_pos_arc_plane
   global mom_sys_cir_vector
   global mom_sys_helix_pitch_type
   global mom_helix_pitch
   global mom_prev_pos mom_pos_arc_center
   global PI

   switch $mom_pos_arc_plane {
      XY { MOM_suppress once ZC ; set cir_index 2 }
      YZ { MOM_suppress once XC ; set cir_index 0 }
      ZX { MOM_suppress once YC ; set cir_index 1 }
   }

   switch $mom_sys_helix_pitch_type {
      none { }
      rise_revolution { set pitch $mom_helix_pitch }
      rise_radian { set pitch [expr $mom_helix_pitch / ($PI * 2.0)]}
      other {
#
#	Place your custom helix pitch code here
#
      }
      default { set mom_sys_helix_pitch_type "none" }
   }

   MOM_force once X Y Z

   if {$mom_sys_helix_pitch_type != "none"} {
      MOM_force once XC YC ZC

      switch $mom_sys_cir_vector {
         "Vector - Arc Center to Start" {
            set mom_prev_pos($cir_index) $pitch
            set mom_pos_arc_center($cir_index) 0.0
         }
         "Vector - Arc Start to Center" {
            set mom_prev_pos($cir_index) 0.0
            set mom_pos_arc_center($cir_index) $pitch
         }
         "Unsigned Vector - Arc Center to Start" {
            set mom_prev_pos($cir_index) 0.0
            set mom_pos_arc_center($cir_index) $pitch
         }
         "Vector - Absolute Arc Center" {
            set mom_pos_arc_center($cir_index) $pitch
         }
      }
   }

  MOM_do_template circle_center


  global mom_prev_mcs_goto
  global polar_angle
  set  polar_angle  0.0

  switch $mom_pos_arc_plane {
      XY { set y [ expr ($mom_prev_mcs_goto(1) - $mom_arc_center(1))] ;
           set x [ expr ($mom_prev_mcs_goto(0) - $mom_arc_center(0))] ;
         }
      YZ { set y [ expr ($mom_prev_mcs_goto(2) - $mom_arc_center(2))] ;
           set x [ expr ($mom_prev_mcs_goto(1) - $mom_arc_center(1))] ;
         }
      ZX { set y [ expr ($mom_prev_mcs_goto(0) - $mom_arc_center(0))] ;
           set x [ expr ($mom_prev_mcs_goto(2) - $mom_arc_center(2))] ;
         }
   }

  set polar_angle [ ATAN $y $x ]

  MOM_do_template helix_linear


  global mom_sys_leader
  set mom_sys_leader(Circle_angle) "IPA"
  set mom_sys_leader(X) "IX"
  set mom_sys_leader(Y) "IY"
  set mom_sys_leader(Z) "IZ"

  if {$mom_arc_direction == "CLW"} {
  	#-
     		set mom_arc_angle [ expr  (-1.0)*abs($mom_arc_angle) ]
     		MOM_do_template helix_end_cw
  } elseif {$mom_arc_direction == "CCLW" } {
  	#+
    		set mom_arc_angle [ expr  abs($mom_arc_angle) ]
    		MOM_do_template helix_end_ccw
  }

  set mom_arc_angle [ expr  abs($mom_arc_angle) ]
  set mom_sys_leader(Circle_angle) "PA"
  set mom_sys_leader(X) "X"
  set mom_sys_leader(Y) "Y"
  set mom_sys_leader(Z) "Z"

}


##################################################################################################


#=============================================================
proc PB_CMD_cycle_init { } {
#=============================================================
  global cycle_name ;
  global cycle_init_flag ;

	global mom_motion_event
	global mom_tool_diameter
	global mom_pos mom_prev_pos
	global mom_alt_pos  mom_prev_alt_pos
	global mom_cycle_delay  mom_cycle_delay_revs  mom_cycle_delay_mode
 	global mom_cycle_step1 mom_cycle_step2  mom_cycle_step3
  	global mom_cycle_feed_to mom_cycle_feed_to_pos
	global mom_cycle_retract_mode  mom_cycle_retract_to
	global mom_cycle_clearance_plane
	global mom_cycle_cam

  	global dwell_at_top
  	global surface_coordinate
  	global depth_bottom
  	global step1  step2  step3

  global cycle_step ;

  #   
  if {$mom_prev_alt_pos(2)!=$mom_alt_pos(2)} { set  cycle_step  0; }

  if {$cycle_step==0} {

  	set surface_coordinate  $mom_alt_pos(2)
	set depth_bottom  [ expr $mom_cycle_feed_to_pos(2) - $mom_alt_pos(2) ]
  	set dwell_at_top  0.0
	set step1  $mom_cycle_step1
	if {$step1==0.0} { set step1 [ expr abs($depth_bottom) ] ; }

	switch $cycle_name {

	 DRILL {

 	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204
 	MOM_suppress Always  Q211

 	MOM_do_template cycle_200_drill

  	# MOM_do_template cycle_200
  	# MOM_suppress always N
  	# MOM_do_template tnc_q200 ; # 1-  
  	# MOM_do_template tnc_q201 ; # 
  	# MOM_do_template tnc_q206 ; #    
  	# MOM_do_template tnc_q202 ; # 
  	# MOM_do_template tnc_q210 ; #    
  	# MOM_do_template tnc_q203 ; #  
 	# MOM_do_template tnc_q204 ; # 2-  
	# MOM_suppress off    N

	}

	DRILL_DWELL {

  	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204 Q211

  	MOM_do_template cycle_200_drill

  	# MOM_do_template cycle_200
  	# MOM_suppress always N
  	# MOM_do_template tnc_q200 ; # 1-  
  	# MOM_do_template tnc_q201 ; # 
  	# MOM_do_template tnc_q206 ; #    
  	# MOM_do_template tnc_q202 ; # 
  	# MOM_do_template tnc_q210 ; #    
  	# MOM_do_template tnc_q203 ; #  
 	# MOM_do_template tnc_q204 ; # 2-  
  	# MOM_do_template tnc_q211 ; #    
	# MOM_suppress off   N
	}

	DRILL_DEEP {

	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204 Q211 Q212 Q213 Q205 Q208 Q256

	set step1  $mom_cycle_step1
	set step2  $mom_cycle_step2
	set step3  $mom_cycle_step3
	if {$step1==0.0} {
	  set step1 $mom_tool_diameter ;
	  set step2 0.0 ;
	 } else {
 	     if {$step2<0.0} {
 	        set step2 [ expr abs($step2) ] ;
 	      } else {
 	     	if {$step2<=$step1} { set step2 [ expr $step1 - $step2 ] ; }
 	     	}
 	  }
	if {$step3==0.0} { set mom_cycle_cam 0 ; }
        if {$mom_cycle_cam==0} { set  step3 0.0 ;  }

	MOM_do_template cycle_203_drill_deep

	#if {$mom_cycle_delay==0.0} { MOM_suppress Always Q211 ; }

  	#MOM_do_template cycle_203
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200 ; # 1-  
  	#MOM_do_template tnc_q201 ; # 
  	#MOM_do_template tnc_q206 ; #    
  	#MOM_do_template tnc_q202 ; #  
  	#MOM_do_template tnc_q210 ; #    
  	#MOM_do_template tnc_q203 ; #  
 	#MOM_do_template tnc_q204 ; # 2-  
 	#MOM_do_template tnc_q212 ; #    
  	#MOM_do_template tnc_q213 ; #   
  	#MOM_do_template tnc_q205 ; # .  
  	#MOM_do_template tnc_q211 ; #    
  	#MOM_do_template tnc_q208 ; #      
	#MOM_force once Q256
  	#MOM_do_template tnc_q256 ; #     
  	#MOM_suppress off    N
	}

	DRILL_BREAK_CHIP {

   	MOM_force once Q200 Q201 Q206 Q202 Q210 Q203 Q204 Q211 Q212 Q213 Q205 Q208 Q256

	set step1  $mom_cycle_step1
	set step2  $mom_cycle_step2
	set step3  $mom_cycle_step3
	if {$step1==0.0} {
	  set step1 $mom_tool_diameter ;
	  set step2 0.0 ;
	 } else {
 	     if {$step2<0.0} {
 	        set step2 [ expr abs($step2) ] ;
 	      } else {
 	     	if {$step2<=$step1} { set step2 [ expr $step1 - $step2 ] ; }
 	     	}
 	  }
	if {$step3==0.0} { set mom_cycle_cam 0 ; }
        if {$mom_cycle_cam==0} { set  step3 0.0 ;  }

	MOM_do_template cycle_203_drill_deep

  	#MOM_do_template cycle_203
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200 ; # 1-  
  	#MOM_do_template tnc_q201 ; # 
  	#MOM_do_template tnc_q206 ; #    
  	#MOM_do_template tnc_q202 ; #  
  	#MOM_do_template tnc_q202_1 ; #  
  	#MOM_do_template tnc_q210 ; #    
  	#MOM_do_template tnc_q203 ; #  
  	#MOM_do_template tnc_q208 ; #
 	#MOM_do_template tnc_q204 ; # 2-  
 	#MOM_do_template tnc_q212 ; #    
	#set mom_cycle_cam $mom_cycle_cam
  	#MOM_do_template tnc_q213 ; #   
  	#MOM_do_template tnc_q205 ; # .  
  	#MOM_do_template tnc_q211 ; #    
  	#MOM_do_template tnc_q208 ; #      
	#MOM_force once Q256
  	#MOM_do_template tnc_q256 ; #     
  	#MOM_do_template tnc_q257 ; #    
  	#MOM_suppress off    N

	}

	TAP {

	MOM_force once Q200 Q201 Q239 Q203 Q204 Q211

 	MOM_do_template cycle_207_tap

  	#MOM_do_template cycle_203
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200 ; # 1-  
  	#MOM_do_template tnc_q201 ; # 
  	#MOM_do_template tnc_q202_1 ; # 
  	#MOM_do_template tnc_q203 ; #  
 	#MOM_do_template tnc_q204 ; # 2-  
  	#MOM_suppress off    N

	}

	BORE_DWELL {

   	MOM_force once Q200 Q201 Q206 Q211 Q208 Q203 Q204 Q214 Q336

   	MOM_do_template cycle_202_boring

  	#MOM_do_template cycle_202
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200
  	#MOM_do_template tnc_q201
  	#MOM_do_template tnc_q206
  	#MOM_do_template tnc_q211
  	#MOM_do_template tnc_q208
 	#MOM_do_template tnc_q203
 	#MOM_do_template tnc_q204
	#set mom_cycle_cam $mom_cycle_cam
  	#MOM_do_template tnc_q214
  	#MOM_do_template tnc_q336
  	#MOM_suppress off    N

	}

	BORE {

   	MOM_force once Q200 Q201 Q206 Q211 Q208 Q203 Q204 Q214 Q336

   	MOM_do_template cycle_202_boring

  	#MOM_do_template cycle_202
  	#MOM_suppress always N
  	#MOM_do_template tnc_q200
  	#MOM_do_template tnc_q201
  	#MOM_do_template tnc_q206
  	#MOM_do_template tnc_q208
 	#MOM_do_template tnc_q203
 	#MOM_do_template tnc_q204
	#set mom_cycle_cam $mom_cycle_cam
  	#MOM_do_template tnc_q214
  	#MOM_do_template tnc_q336
  	#MOM_suppress off    N

	}


	default { ; }
	}


  }
  incr cycle_step ;

  	MOM_force once X Y
	MOM_do_template cycle_xy
	#  CYCLE CALL
	# MOM_do_template cycle_call

  return ;
}

#=============================================================
proc  MOM_cycle_plane_change {} {
#        .
#=============================================================
  global cycle_init_flag ;   set cycle_init_flag TRUE

  global mom_pos mom_prev_pos

  if {$mom_pos(2) <= $mom_prev_pos(2) } {
   	MOM_do_template rapid_traverse_xy
   	MOM_do_template rapid_spindle_z
   } else {
   	MOM_do_template rapid_spindle_z
   	MOM_do_template rapid_traverse_xy
    }

#    	global mom_pos mom_prev_pos mom_pos_z mom_prev_pos_z
#
#   	if {$mom_pos_z < $mom_prev_pos_z } {
#  		MOM_do_template rapid_cycle_bc
#   		MOM_do_template rapid_cycle_xy
#   		MOM_do_template rapid_cycle_z
#   	} else {
#   		MOM_do_template rapid_cycle_z
#   		MOM_do_template rapid_cycle_bc
#   		MOM_do_template rapid_cycle_xy
#   	}
#  	MOM_do_template cycle_call
#  	set mom_prev_pos_z $mom_pos_z

}


#=============================================================
proc MOM_drill { } {
#       .
#=============================================================

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_drill_move { } {
#         .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_dwell { } {
#         .
#=============================================================

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL_DWELL
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_drill_dwell_move { } {
#           .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_deep { } {
#        .
#=============================================================

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL_DEEP
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_drill_deep_move { } {
#        
#  .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_break_chip { } {
#        
#  .
#=============================================================
  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name DRILL_BREAK_CHIP
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ;

}


#=============================================================
proc  MOM_drill_break_chip_move { } {
#       
#     .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE

}


#=============================================================
proc MOM_tap { } {
#        .
#=============================================================
  global cycle_name
  global cycle_init_flag

  set cycle_init_flag TRUE
  set cycle_name TAP

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_tap_move { } {
#       
#   .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore { } {
#       .
#=============================================================
  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_bore_move { } {
#       
#  .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_drag { } {
#       .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE_DRAG
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  
}


#=============================================================
proc  MOM_bore_drag_move { } {
#       
#  .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_no_drag { } {
#      
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_no_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE_NO_DRAG
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  
}


#=============================================================
proc  MOM_bore_no_drag_move { } {
#        
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_no_drag  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE

}


#=============================================================
proc MOM_bore_manual { } {
#      
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc  MOM_bore_manual_move { } {
#        
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc MOM_bore_dwell { } {
#         .
#=============================================================
  global cycle_name
  global cycle_init_flag

  set cycle_init_flag TRUE
  set cycle_name BORE_DWELL

  global cycle_step ; set  cycle_step 0 ; #  

}


#=============================================================
proc  MOM_bore_dwell_move { } {
#        
#   .
#=============================================================
	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_back { } {
#        .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_back  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

  global cycle_name ;
  global cycle_init_flag ;

  set cycle_name BORE_BACK
  set cycle_init_flag TRUE

  global cycle_step ; set  cycle_step 0 ; #  
}


#=============================================================
proc  MOM_bore_back_move { } {
#        
#  .
#=============================================================

 	global mom_warning_info
	set mom_warning_info " MOM_bore_back  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

	global  cycle_init_flag
	PB_CMD_cycle_init
	set cycle_init_flag FALSE

}


#=============================================================
proc MOM_bore_manual_dwell { } {
#        
#    .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual_dwell  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc  MOM_bore_manual_dwell_move { } {
#        
#      .
#=============================================================

	global mom_warning_info
	set mom_warning_info " MOM_bore_manual_dwell  "
        MOM_output_to_listing_device $mom_warning_info  ;   MOM_catch_warning ;
        return ;

}


#=============================================================
proc  MOM_drill_counter_sink {} {
#       Standart Drill - Counter Sink.
#=============================================================
	MOM_drill
}


#=============================================================
proc  MOM_drill_counter_sink_move {} {
#       
# Standart Drill - Counter Sink.
#=============================================================
	MOM_drill_move
}


#=============================================================
proc  MOM_drill_csink_dwell {} {
#      
# Standart Drill - Counter Sink Dwell.
#=============================================================
	MOM_drill_dwell
}


#=============================================================
proc  MOM_drill_csink_dwell_move {} {
#       
# Standart Drill - Counter Sink.
#=============================================================
	MOM_drill_dwell_move
}

######################################################################################################

#=============================================================
proc  MOM_load_tool {} {
#       LOAD/TOOL.  
#       MOM_msys.
#=============================================================

}


#=============================================================
proc  MOM_sequence_number {} {
#      Sequence Number.
#=============================================================
    SEQNO_SET
}


#=============================================================
proc  MOM_set_modes {} {
#       Set Mode.
#=============================================================
	global mom_output_mode
	global mom_arc_mode
	global mom_feed_rate_output_mode
	global mom_parallel_to_axis
	global mom_machine_mode
	global mom_modes_text
	global g_output_mode

# "ABSOLUTE", "INCREMENTAL"
	if {$mom_output_mode == "ABSOLUTE"} {
		set g_output_mode "G90"
		MOM_incremental OFF X Y Z Axis_4th Axis_5th
	} elseif {$mom_output_mode == "INCREMENTAL"} {
		set g_output_mode "G91"
		MOM_incremental ON X Y Z Axis_4th Axis_5th
	}
# "LINEAR", "CIRCULAR"
	if {$mom_arc_mode == "LINEAR"} {
	} elseif {$mom_arc_mode == "CIRCULAR"} {
	}
# "OFF", "IPM", "IPR", "MMPM", "MMPR", "INVERSE"
	if {$mom_feed_rate_output_mode == "FPM"} {
	} elseif {$mom_feed_rate_output_mode == "FPR"} {
	} elseif {$mom_feed_rate_output_mode == "INVERSE"} {
	} elseif {$mom_feed_rate_output_mode == "OFF"} {
	}
# "ZAXIS", "WAXIS", "UAXIS"
	if {$mom_parallel_to_axis == "ZAXIS"} {
	} elseif {$mom_parallel_to_axis == "WAXIS"} {
	} elseif {$mom_parallel_to_axis == "UAXIS"} {
	}
# "MILL", "TURN", "PUNCH", "LASER", "TORCH", "WIRE"
	if {$mom_machine_mode == "MILL"} {
	} elseif {$mom_machine_mode == "TURN"} {
	} elseif {$mom_machine_mode == "PUNCH"} {
	} elseif {$mom_machine_mode == "LASER"} {
	} elseif {$mom_machine_mode == "TORCH"} {
	} elseif {$mom_machine_mode == "WIRE"} {
	}
}


#=============================================================
proc MOM_cutcom_on { } {
#       CUTCOM/ON
#=============================================================
  global mom_cutcom_mode mom_cutcom_status
  global mom_cutcom_adjust_register_defined  mom_cutcom_adjust_register
  global cutcom_mode code_cutcom cutcom_on

proc outCutcom { } {
 global mom_tool_number
 global cutcom_mode code_cutcom cutcom_on
 global mom_cutcom_adjust_register_defined  mom_cutcom_adjust_register

 if { $mom_cutcom_adjust_register_defined!=0} {
	set line_tool [format "TOOL CALL %d.%d Z" $mom_tool_number $mom_cutcom_adjust_register ]
	MOM_output_literal "$line_tool"
    	set   code_cutcom  1
 }
 if { $mom_cutcom_adjust_register_defined==0 && $code_cutcom==1 } {
	set line_tool [format "TOOL CALL %d Z" $mom_tool_number ]
	MOM_output_literal "$line_tool"
 }

}

    switch $mom_cutcom_mode {
    	"OFF" {
         	set cutcom_mode "0"
		#set mom_cutcom_adjust_register  0
	}
	"RIGHT" {
	     outCutcom
       	     set cutcom_mode "R"
      	}
      	"LEFT" {
      	     outCutcom
  	     set cutcom_mode "L"
      	}
      	default { set cutcom_mode "R" ; }
   }

   if {$mom_cutcom_status == "OFF"} {
   	set cutcom_mode "0"
	#set  mom_cutcom_adjust_register  0
    }

   set cutcom_on 1
}


#=============================================================
proc MOM_cutcom_off { } {
#       CUTCOM/OFF
#=============================================================
	global cutcom_mode
	set cutcom_mode "0"
	set cutcom_on 0
	MOM_force once R
}


#=============================================================
proc MOM_spindle_rpm { } {
#       SPLIND/RPM
#=============================================================
	global mom_tool_number mom_spindle_speed mom_contact_status
	global mom_spindle_speed mom_operation_type mom_operation_name
	global mom_tool_name mom_tool_diameter mom_tool_corner1_radius status_block_create
	global spindle_off_flag  line status_tool_change line_tool mom_output_vectors_on
	global mom_imported_path_status

#         
#       iTNC-530
	if {$status_block_create == "0"} {
		MOM_block_create
#		MOM_output_literal "L M129"
	}

	if {$mom_tool_number == 0} {
  		if {[info exists mom_imported_path_status]==1} {
    			if {"NO"==[string toupper "$mom_imported_path_status"]} {
				MOM_abort "\n\nError!\n\t      0   $mom_operation_name.\n\n"
			}
		}
    	}

	if {$status_tool_change == 0} {
#		MOM_output_literal "L M129"
		if {$mom_contact_status == "ON" || $mom_output_vectors_on == "ON"} {
			set line_tool [format "TOOL CALL %d Z S%.0f DL=0.0 DR=0.0 DR2=0.0" $mom_tool_number $mom_spindle_speed]
			MOM_output_literal "$line_tool"
			set line [format "; TOOL: %s D=%.2f " $mom_tool_name $mom_tool_diameter ]
			if {[info exists mom_tool_corner1_radius]} {
				append line [format "r1=%.2f" $mom_tool_corner1_radius ]
			}
   			MOM_output_literal "$line"
   			MOM_output_literal "; POSITIVE VALUES DL, DR, DR2 MEAN THAT THE SIZE MORE ORIGINAL"
			MOM_output_literal "; NEGATIVE VALUES DL, DR, DR2 MEAN THAT THE SIZE LESS ORIGINAL"
			MOM_output_literal "; WARNING: IN 3D CUTTER COMPENSATION MODE"
			MOM_output_literal "; USE THE TOOL OF GREATER DIAMETER MAY GOUGED OF THE PART !!!"
		} else {
			set line_tool [format "TOOL CALL %d Z S%.0f DR+0.0" $mom_tool_number $mom_spindle_speed]
			MOM_output_literal "$line_tool"
				        if {[info exists mom_imported_path_status]==1} {
                          if {"YES"==[string toupper "$mom_imported_path_status"]} {
                               set mom_warning_info "WARNING: =$mom_operation_name -   ( -   !)"
                            } else {
      	set line [format "; TOOL: %s D=%.2f " $mom_tool_name $mom_tool_diameter ]
			if {[info exists mom_tool_corner1_radius]} {
				append line [format "r1=%.2f" $mom_tool_corner1_radius ]
			}
   			MOM_output_literal "$line"
                          }
                          #MOM_reload_kinematics
                         }

		}

		if {$mom_spindle_speed == 0.0} {
  			if {[info exists mom_imported_path_status]==1} {
    				if {"NO"==[string toupper "$mom_imported_path_status"]} {
					MOM_abort "\n\nError!\n\t      0   $mom_operation_name .\n\n"
				}
			}
		}
   		MOM_do_template spindle_rpm
   		set spindle_off_flag 1
   		set status_tool_change 1
   	} else {
   		   MOM_do_template tool_call_s
   		if {$spindle_off_flag == 0}	{
	                MOM_force once M_spindle F
   			MOM_do_template spindle_rpm
   			set spindle_off_flag 1
		}
      }
	if {$mom_operation_type == "Variable-axis Surface Contouring"	||
		$mom_operation_type == "Sequential Mill Main Operation"	||
		$mom_operation_type == "Zig-Zag Surface" } {
		#MOM_output_literal "L M126"
	}
}


#=============================================================
proc  MOM_spindle_off {} {
#       SPLIND/OFF.
#=============================================================
	global spindle_off_flag

         MOM_do_template spindle_off
         set spindle_off_flag 0
}


#=============================================================
proc  MOM_coolant_on {} {
#       COOLANT/ON.
#=============================================================
	COOLANT_SET
	MOM_force Once M_coolant
	MOM_do_template coolant_on
}


#=============================================================
proc  MOM_coolant_off {} {
#       COOLANT/OFF.
#=============================================================
	COOLANT_SET
	MOM_do_template coolant_off
}


#=============================================================
proc  MOM_opstop {} {
#       OPTIONAL STOP.
#=============================================================
	MOM_do_template opstop
}


#=============================================================
proc  MOM_stop {} {
#       PROGRAM STOP.
#=============================================================
	MOM_do_template stop
}


#=============================================================
proc  MOM_opskip_on {} {
#       OPTIONAL SKIP/ON.
#=============================================================
	MOM_set_line_leader always "/"
}


#=============================================================
proc  MOM_opskip_off {} {
#       OPTIONAL SKIP/OFF.
#=============================================================
	MOM_set_line_leader off "/"
}


#=============================================================
proc  MOM_delay {} {
#       DELAY.
#=============================================================
	global mom_delay_value

	MOM_do_template delay_1
	MOM_do_template delay_2
}


#=============================================================
proc  MOM_auxfun {} {
#      
# AUXILIARY FUNCTION.
#=============================================================
	MOM_do_template auxiliary
}


#=============================================================
proc  MOM_prefun {} {
#      
# PREPARATORY FUNCTION.
#=============================================================
	MOM_do_template preparatory
}


#=============================================================
proc  MOM_length_compensation {} {
#      
# TOOL LENGTH COMPENSATION.
#=============================================================
}


#=============================================================
proc  MOM_tool_preselect {} {
#       TEXT.
#=============================================================
}


#=============================================================
proc MOM_zero {} {
#        ZERO
#=============================================================
	global mom_work_coordinate_number
	MOM_output_literal "CYCL DEF 7.0 DATUM SHIFT"
	MOM_output_literal "CYCL DEF 7.1 #$mom_work_coordinate_number"
#	MOM_output_literal "CYCL DEF 7.2 Y0.0"
#	MOM_output_literal "CYCL DEF 7.3 Z0.0"
	MOM_output_literal "; SET NULL POINT SHIFT"

		MOM_force once  X Y Z
}


#=============================================================
proc  MOM_text {} {
#        .
#=============================================================
	global mom_user_defined_text
	global mom_record_fields
	global mom_record_text
	global MCSROT_mode
	global MCSROT_flag
	global is_MCSROT_matrix_set
	global first_move_after_MCSROT
	global prog_number mom_work_coordinate_number

	switch $mom_record_fields(0) {
	"INSERT"
	{
		MOM_output_literal $mom_record_text
	}
	"ZERO"
	{
		set mom_work_coordinate_number $mom_record_fields(1)
		MOM_zero
	}
	"MCSROT"
	{
		set MCSROT_mode $mom_record_fields(1)
		if {$mom_record_fields(1) == "OFF"} {
			set MCSROT_flag 0
			set is_MCSROT_matrix_set 0
			set first_move_after_MCSROT 0
			MOM_suppress off K
			MOM_do_template cancel_rotate_mcs
		} else {
			set MCSROT_flag 1
		}
	}
	"PARTNO"
	{
		set mom_record_text [string trim $mom_record_text " "]
		set temp [split $mom_record_text " "]
		set prog_number [lindex $temp 0]
		PROGRAM_START
	}
	default
		{ MOM_output_literal "$mom_user_defined_text" }
	}
}


#=============================================================
proc MOM_before_motion {} {
#        .
#=============================================================
   global mom_motion_type
   FEEDRATE_SET

    switch $mom_motion_type {
      ENGAGE   {PB_engage_move}
      APPROACH {PB_approach_move}
      FIRSTCUT {PB_first_cut}
    }


    if { [llength [info commands PB_CMD_kin_before_motion]] } { PB_CMD_kin_before_motion }
    if { [llength [info commands PB_CMD_before_motion]] }     { PB_CMD_before_motion }

}


#=============================================================
proc PB_CMD_before_motion { } {
#=============================================================
  global mom_current_motion  mom_motion_event  mom_motion_type  mom_operation_type
  global mom_tool_axis mom_prev_tool_axis
  global mom_mcs_goto mom_prev_mcs_goto
  global mom_pos mom_alt_pos mom_out_angle_pos
  global mom_clearance_plane_point mom_clearance_plane_status
  global mom_feed_rate  mom_motion_distance
  global mom_nxt_motion_type mom_nxt_motion_event  mom_nxt_pos
  global out_m128 nn mom_pos_a1 mom_alt_pos_a1
  global mom_machine_time_dmu_1 mom_machine_time_dmu
  global leader_4th leader_5th  mom_rotation_angle
  set leader_4th "A"
  set leader_5th "C"

#MOM_output_literal "NXT = $mom_nxt_motion_type"
#MOM_output_literal "NEXT X = $mom_nxt_pos(0)"

#       DMU

    set   n1 [ expr ($mom_mcs_goto(0)-$mom_prev_mcs_goto(0) )]
    set   n2 [ expr ($mom_mcs_goto(1)-$mom_prev_mcs_goto(1) )]
    set   n3 [ expr ($mom_mcs_goto(2)-$mom_prev_mcs_goto(2) )]
#   MOM_output_literal "NXT = $mom_motion_event"

    set  n4 [ expr (sqrt($n1*$n1+$n2*$n2+$n3*$n3)/$mom_feed_rate)]
    set  n5 [ expr ( $mom_motion_distance /$mom_feed_rate)]
    if {$mom_motion_event=="circular_move" } {
          set mom_machine_time_dmu_1  [ expr ( $mom_machine_time_dmu_1 + $n5 )]
     } else {
      set mom_machine_time_dmu  [ expr ( $mom_machine_time_dmu + $n4 )]
      set mom_machine_time_dmu_1  [ expr ( $mom_machine_time_dmu_1 + $n4 )]
    }
    set i [format "%-.6f" $mom_tool_axis(0)]
    set j [format "%-.6f" $mom_tool_axis(1)]
    set k [format "%-.6f" $mom_tool_axis(2)]

    set i1 [format "%-.6f" $mom_prev_tool_axis(0)]
    set j1 [format "%-.6f" $mom_prev_tool_axis(1)]
    set k1 [format "%-.6f" $mom_prev_tool_axis(2)]

    if {$i=="0.0" && $j=="0.0" &&  ($k=="1.0" || $k=="-1.0" ) && $mom_rotation_angle==0.0 } {
	set  out_m128  129
#	MOM_force once XC YC
#	MOM_suppress once M128
	set mom_out_angle_pos(1) 0
#	set c_value 0
#       return;
    } else {
        set out_m128  128
   }
   PB_limit_angle

}


#=============================================================
proc PB_limit_angle {} {
#      .
#=============================================================
 global mom_warning_info  mom_seqnum
 global nn warning_1
 if {$mom_warning_info== "unable to determine valid rotary positions"} {
    incr nn
    set warning_1($nn) [format "; :   %.0f      -120" $mom_seqnum ]
    set mom_warning_info ""
  }
}


#=============================================================
proc PB_approach_move { } {
#=============================================================
}


#=============================================================
proc PB_engage_move { } {
#=============================================================
}


#=============================================================
proc PB_first_cut { } {
#=============================================================
}


#=============================================================
proc PB_first_linear_move { } {
#=============================================================
}


#=============================================================
proc PB_return_move { } {
#=============================================================
}


#=============================================================
proc MOM_machine_mode {} {
#      .
#=============================================================
	MOM_start_of_group
}


######################################################################################################


#=============================================================
proc MOM_smooth_tool_path { } {
#      .
#=============================================================
	global mom_smooth_path
}


#=============================================================
proc MOM_tolerance_cycle { } {
#       
#=============================================================
	global mom_tolerance_on_off
	global mom_operation_type
	global mom_inside_outside_tolerances
	global tolerances
	global temp mom_tolerance

	MOM_force once Tol

  	if {$mom_operation_type == "Variable-axis Surface Contouring"  	|| \
		$mom_operation_type == "Cavity Milling" 		|| \
		$mom_operation_type == "Fixed-axis Surface Contouring"  || \
		$mom_operation_type == "Planar Milling"  		|| \
		$mom_operation_type == "Sequential Mill Main Operation" || \
		$mom_operation_type == "Zig-Zag Surface" } {
  		set temp [expr $mom_inside_outside_tolerances(0) + $mom_inside_outside_tolerances(1)]
 		set tolerances [expr $temp/2]
#       set tolerances  $mom_tolerance
       set   mom_tolerance_on_off   "ON"
  	}
}


#=============================================================
proc MOM_spindle_orient { } {
#      .
#=============================================================
	global mom_angle_orient
	MOM_force once Angle
	MOM_do_template spindle_orient_1
	MOM_do_template spindle_orient_2
}


proc COUNT_alk {x y alk} {
#_______________________________________________________________________________
# This procedure is executed for  ygol  megdy  vectorom i X
#_______________________________________________________________________________
	   set pi 3.1415927
       if {$x == 0. && $y==0.} {
	       set alk [expr (3.*$pi/2.)]
	       return $alk
	       }
      if {$x < 0.} {
	       set alk [expr ($pi + atan($y/$x))]
	       return $alk
	       }
      if {$x == 0.} {
	    if {$y > 0.} {
	       set alk [expr ($pi/2)]
	       } else {
		set alk [expr (3.*$pi/2.)]
		}
		  return $alk
	       }
       if {$x > 0.} {
	      set alk [expr (atan($y/$x))]
	       if {$alk < 0.} { set alk [expr ($alk+2.*$pi)] }
	       if {$alk == 0.} { set alk 0. }
	       }
	      return $alk
}
#=============================================================
proc MOM_rotate_dmu { } {
#       
#=============================================================
	global mom_rotate_axis_type mom_rotation_angle  status_rot  status_rot_m
	global a_angle b_angle  c_angle  mom_rotation_angle_A mom_rotation_angle_B mom_rotation_angle_C mom_rotation_reference_mode

                set status_rot 1
                set status_rot_m 1
		if {[info exists mom_rotation_angle_A]} { 	set a_angle $mom_rotation_angle_A }

		if {[info exists mom_rotation_angle_B]} { 	set b_angle $mom_rotation_angle_B }

		if {[info exists mom_rotation_angle_C]} { 	set c_angle $mom_rotation_angle_C }

#   19 (  )      

#		MOM_do_template rotate_bc
#	MOM_output_literal "$rot_table_1"
	 if { $mom_rotation_reference_mode=="ON"} {
	 	MOM_output_literal "CYCL DEF 19.0 WORKING PLANE"
                MOM_output_literal "CYCL DEF 19.1 B+0 C+0 F2000"
	 	MOM_output_literal "CYCL DEF 19.0 WORKING PLANE"
                MOM_output_literal "CYCL DEF 19.1"
                        }
         if { $a_angle==0.0 && $b_angle==0.0 && $c_angle==0.0 } {
                   	MOM_suppress off Axis_4th Axis_5th M128
#                    	MOM_force once Axis_4th Axis_5th M128
                    	       set status_rot_m 0
                }
}


#=============================================================
proc MOM_rotate { } {
#=============================================================
  global mom_rotate_axis_type mom_rotation_mode mom_rotation_direction
  global mom_rotation_angle mom_rotation_reference_mode
  global mom_kin_machine_type mom_kin_4th_axis_direction mom_kin_5th_axis_direction
  global mom_kin_4th_axis_leader mom_kin_5th_axis_leader
  global mom_kin_4th_axis_leader mom_kin_5th_axis_leader mom_pos
  global mom_out_angle_pos mom_prev_out_angle_pos
  global unlocked_prev_pos mom_sys_leader
  global mom_kin_4th_axis_min_limit mom_kin_4th_axis_max_limit
  global mom_kin_5th_axis_min_limit mom_kin_5th_axis_max_limit
  global mom_prev_pos out_m128

   if {![info exists mom_rotation_angle]} {return}

  #
  #  Determine which axis the user wanted, fourth or fifth.
  #
   switch $mom_rotate_axis_type {
      AAXIS {
         set axis [AXIS_SET $mom_rotate_axis_type]
      }
      BAXIS {
         set axis [AXIS_SET $mom_rotate_axis_type]
      }
      CAXIS {
      #   set axis [AXIS_SET $mom_rotate_axis_type]
            set axis 4

      }
      TABLE {
         set axis 3
      }
      HEAD {
         if { $mom_kin_machine_type == "5_axis_head_table"  ||  $mom_kin_machine_type == "5_AXIS_HEAD_TABLE" } {
            set axis 3
         } else {
            set axis 3
         }
      }
      default {
         set axis 3
      }
   }
#MOM_output_literal "axis  $axis"
   switch $mom_rotation_mode {
      NONE {
         set angle $mom_rotation_angle
         set mode 0
      }
      ATANGLE {
         set angle $mom_rotation_angle
         set mode 0
      }
      ABSOLUTE {
         set angle $mom_rotation_angle
         set mode 1
      }
      INCREMENTAL {
         set angle [expr $mom_pos($axis) + $mom_rotation_angle]
         set mode 0
      }
   }
#MOM_output_literal "mode  $mode angle $angle"
   switch $mom_rotation_direction {
      NONE {
         set dir 0
      }
      CLW {
         set dir 1
      }
      CCLW {
         set dir -1
      }
   }
#MOM_output_literal "dir  $dir"
   set ang [LIMIT_ANGLE $angle]
   set mom_pos($axis) $ang
#MOM_output_literal "ang   $ang "


   if {$axis == "3" && ![info exists mom_prev_out_angle_pos(0)]} {
      set mom_prev_out_angle_pos(0) [MOM_ask_address_value fourth_axis]
      if {$mom_prev_out_angle_pos(0) == ""} {set mom_prev_out_angle_pos(0) 0.0}
   }


   if {$axis == "4" && ![info exists mom_prev_out_angle_pos(1)]} {
      set mom_prev_out_angle_pos(1) [MOM_ask_address_value fifth_axis]
      if {$mom_prev_out_angle_pos(1) == ""} {set mom_prev_out_angle_pos(1) 0.0}
   }

   set p [expr $axis + 1]
   set a [expr $axis - 3]
   if {$axis == "3" && $mom_kin_4th_axis_direction == "MAGNITUDE_DETERMINES_DIRECTION"} {
      set dirtype 0
      global mom_sys_4th_axis_dir_mode
      if [info exists mom_sys_4th_axis_dir_mode] {
        if {$mom_sys_4th_axis_dir_mode == "ON"} {
          set del $dir
          if {$del == 0} {
            set del [expr $ang-$mom_prev_pos(3)]
            if {$del > 180.0} {set del [expr $del-360.0]}
            if {$del < -180.0} {set del [expr $del+360.0]}
          }
          global mom_sys_4th_axis_cur_dir
          if {$del > 0.0} {
            global mom_sys_4th_axis_clw_code
            set mom_sys_4th_axis_cur_dir $mom_sys_4th_axis_clw_code
          } elseif {$del < 0.0} {
            global mom_sys_4th_axis_cclw_code
            set mom_sys_4th_axis_cur_dir $mom_sys_4th_axis_cclw_code
          }
        }
      }
   } elseif { $axis == "4"  &&  $mom_kin_5th_axis_direction == "MAGNITUDE_DETERMINES_DIRECTION" } {
      set dirtype 0
      global mom_sys_5th_axis_dir_mode
      if [info exists mom_sys_5th_axis_dir_mode] {
        if {$mom_sys_5th_axis_dir_mode == "ON"} {
          set del $dir
          if {$del == 0} {
            set del [expr $ang-$mom_prev_pos(4)]
            if {$del > 180.0} {set del [expr $del-360.0]}
            if {$del < -180.0} {set del [expr $del+360.0]}
          }
          global mom_sys_5th_axis_cur_dir
          if {$del > 0.0} {
            global mom_sys_5th_axis_clw_code
            set mom_sys_5th_axis_cur_dir $mom_sys_5th_axis_clw_code
          } elseif {$del < 0.0} {
            global mom_sys_5th_axis_cclw_code
            set mom_sys_5th_axis_cur_dir $mom_sys_5th_axis_cclw_code
          }
        }
      }
   } else {
      set dirtype 1
   }

   if {$mode == 1} {
      set mom_out_angle_pos($a) $angle
   } elseif {$dirtype == 0} {

      if {$axis == 3} {
         set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(0)  $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader  mom_sys_leader(fourth_axis)  $mom_kin_4th_axis_min_limit  $mom_kin_4th_axis_max_limit]
      } else {
         set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(1)  $mom_kin_5th_axis_direction   $mom_kin_5th_axis_leader   mom_sys_leader(fifth_axis)  $mom_kin_5th_axis_min_limit  $mom_kin_5th_axis_max_limit]
#MOM_output_literal "mom_out_angle_pos   $mom_out_angle_pos($a) dirtype $dirtype"
      }

 #     if {$axis == 3} {set prot $mom_prev_out_angle_pos(0)}
 #     if {$axis == 4} {set prot $mom_prev_out_angle_pos(1)}
 #     if {$dir == 1 && $mom_out_angle_pos($a) < $prot} {
 #        set mom_out_angle_pos($a) [expr $mom_out_angle_pos($a) + 360.0]
 #     } elseif {$dir == -1 && $mom_out_angle_pos($a) > $prot} {
 #        set mom_out_angle_pos($a) [expr $mom_out_angle_pos($a) - 360.0]
 #     }
   } elseif {$dirtype == "1"} {

      if {$dir == -1} {
         if {$axis == 3} {
            set mom_sys_leader(fourth_axis) $mom_kin_4th_axis_leader-
         } else {
            set mom_sys_leader(fifth_axis) $mom_kin_5th_axis_leader-
         }
      } elseif {$dir == 0} {
         if {$axis == 3} {
            set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(0)  $mom_kin_4th_axis_direction   $mom_kin_4th_axis_leader   mom_sys_leader(fourth_axis)  $mom_kin_4th_axis_min_limit  $mom_kin_4th_axis_max_limit]
         } else {
            set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(1)  $mom_kin_5th_axis_direction   $mom_kin_5th_axis_leader  mom_sys_leader(fifth_axis)  $mom_kin_5th_axis_min_limit  $mom_kin_5th_axis_max_limit]
         }
      } elseif {$dir == 1} {
         set mom_out_angle_pos($a) $ang
      }
   }



   if {$axis == 3} {
   #   PB_CMD_fourth_axis_rotate_move
#   MOM_do_template fourth_axis_rotate_move
   } else {
    #        set out_m128  128
      if {$mom_rotation_angle == 0.0} {
     MOM_do_template fifth_axis_rotate_move
   }
}
   set mom_prev_pos($axis) $ang
   MOM_reload_variable -a mom_prev_pos
   MOM_reload_variable -a mom_out_angle_pos
}

#=============================================================
proc ROTSET { angle prev_angle dir kin_leader sys_leader min max } {
#=============================================================
#
#  This procedure will take an input angle and format for a specific machine.
#  It will also validate that the angle is within the specified limits of
#  machine.
#
#  angle	      angle to be output.
#  prev_angle	previous angle output.  It should be mom_out_angle_pos
#  dir		can be either MAGNITUDE_DETERMINES_DIRECTION or
#		      SIGN_DETERMINES_DIRECTION
#  kin_leader	leader (usually A, B or C) defined by postbuilder
#  sys_leader     leader that is created by rotset.  It could be C-.
#  min            minimum degrees of travel for current axis
#  max            maximum degrees of travel for current axis
#
#  This procedure is called the follow functions.
#  LOCK_AXIS, RETRACT_ROTARY_AXIS, MOM_rotate, LINEARIZE_OUTPUT and MILL_TURN
#
#
#=============================================================

   upvar $sys_leader lead

#
#  Make sure angle is 0-360 to start with.
#
   LIMIT_ANGLE $angle

   if {$dir == "MAGNITUDE_DETERMINES_DIRECTION"} {
#
#  If magnitude determines direction and total travel is less than or equal
#  to 360, we can assume there is at most one valid solution.  Find it and
#  leave.  Check for the total travel being less than 360 and give a warning
#  if a valid position cannot be found.
#
      set travel [expr $max - $min]
      if {$travel <= 360.0} {
          while {$angle < $min} {set angle [expr $angle + 360.0]}
          while {$angle > $max} {set angle [expr $angle - 360.0]}
          if {$angle < $min} {
              global mom_warning_info
              set mom_warning_info "$kin_leader-axis is under minimum or over maximum.  Assumed default."
              MOM_catch_warning
          }
      } else {
#
#  If magnitude determines direction and total travel is greater than
#  360, we need to find the best solution that cause a move of 180 degree
#  or less.
#
          while {[expr abs([expr $angle - $prev_angle])] > 180.0} {
              if {[expr $angle - $prev_angle] < -180.0} {
                  set angle [expr $angle + 360.0]
              } elseif {[expr $angle - $prev_angle] > 180.0} {
                  set angle [expr $angle - 360.0]
              }
          }
#
#  Check for the best solution being out of the travel limits.  Use the
#  next best valid solution.
#
          while {$angle < $min} {set angle [expr $angle + 360.0]}
          while {$angle > $max} {set angle [expr $angle - 360.0]}
      }
   } elseif {$dir == "SIGN_DETERMINES_DIRECTION"} {
#
#  Sign determines direction.  Determine whether the shortest distance is
#  clockwise or counterclockwise.  If counterclockwise append a "-" sign
#  to the address leader.
#
      set del [expr $angle-$prev_angle]
      if {($del < 0.0 && $del > -180.0) || $del > 180.0} {
          set lead "$kin_leader-"
      } else {
          set lead $kin_leader
      }
#
#  There are no alternate solutions if the position is out of limits.  Give
#  a warning a leave.
#
      if {$angle < $min || $angle > $max} {
          global mom_warning_info
          set mom_warning_info "$kin_leader-axis is under minimum or over maximum.  Assumed default."
          MOM_catch_warning
      }
   }

return $angle
}

#=============================================================
proc LIMIT_ANGLE { a } {
#=============================================================

   while {$a < 0.0} {set a [expr $a+360.0]}
   while {$a >= 360.0} {set a [expr $a-360.0]}

return $a
}


